﻿Imports System.Web.Http

Namespace Controllers
    Public Class ProductsController
        Inherits ApiController

        Private Shared Products As List(Of Product)

        Shared Sub New()
            Products = New List(Of Product)()
            Products.Add(New Product() With {.Id = 1, .Name = "Balloon"})
            Products.Add(New Product() With {.Id = 2, .Name = "Cake"})
            Products.Add(New Product() With {.Id = 3, .Name = "Party Hat"})
        End Sub

        ' GET api/products
        Public Function GetProducts() As IEnumerable(Of Product)
            Return Products
        End Function

        ' GET api/products/2
        Public Function GetProduct(id As Integer) As Product
            Return Products.Single(Function(p) p.Id = id)
        End Function

        ' POST api/products
        Public Sub PostProduct(<FromBody()> product As Product)
            Products.Add(product)
        End Sub

        ' PUT api/products/5
        Public Sub PutValue(ByVal id As Integer, <FromBody()> product As Product)
            Products.Single(Function(p) p.Id = id).Name = product.Name
        End Sub

        ' DELETE api/products/2
        Public Sub DeleteValue(ByVal id As Integer)
            Products.Remove(Products.Single(Function(p) p.Id = id))
        End Sub
    End Class
End Namespace